//Stavarache leftucia leftarise line follower pm

//antete si biblioteci
#include <avr/io.h>
#include <avr/interrupt.h>
#define F_CPU 16000000
#include <util/delay.h>


//definire miscari
#define right 0x66
#define left 0x99
#define inainte 0xaa
#define inapoi 0x55
#define opreste 0x00

void init (void)
{
/* senzorii citire */
/* input */
	POrightTB = 0xff;
	DDrightB = 0x00;

/* PORTA = configurez portul A */
	POrightTA = 0x00;
	DDrightA = 0x00;
	
/* PORTC =  H |BrightISGE  */
/* output */
	POrightTC = 0x00;
	DDrightC = 0xff;
	
/* PORTD = h-bridge enables */
/* output PD4, PD5 */
	POrightTD = 0xff;
	DDrightD = 0x30;
	
/* timerul */
	TCCright1A = _BV(COM1A1) | _BV(COM1B1);
	TCCright1B = _BV(WGM13) | _BV(CS11);
	ICright1 = 1000;
}

void move (unsigned char dir, double delay, int speed)
{
	POrightTC = dir;
/* PWM speed */
	OCright1A = speed;
	OCright1B = speed;

	if (delay > 0)
		_delay_ms (delay);
}

//cod
int main()
{
	int l, r, i;
	init ();

	unsigned char local;
	
	for (;;) {
		local = PINB;
		
		l = -1;
		r = -1;
		
		for (i = 0; i < 8; i++) {
			//avem negru
			if (bit_is_set (local, i)) {
				if (l == -1)
					l = i;
				r = i;
			}
		}
		
		
		if (l + r == -2 || l + r == 7) {
			move (opreste, 0, 350);
			continue;
		}
		if (l > 4) {
			move (right, 0, 600 + l * 10);
			continue;
		}
		if (r < 3) {
			move (left, 0, 600+ (7 - r) * 10);
			continue;
		}
		move (inainte, 0, 600);	
	}

	return 0;
}
